/*

   
===========================================

      (Wave Out).
     -   (Volume
Fader)    (Mute Switch).  
      ,  
    .

*/





#pragma warning (disable: 4115 4127 4201 4214 4514)


#if _DEBUG

  #pragma warning (disable: 4505)

#endif


#define STRICT

#include <windows.h>            //   Windows
#include <commctrl.h>           //    

#include <stdlib.h>             //    C/C++



#include "resource.h"           //  







//
// #########################################################################
//
// 
// 
// #########################################################################
//





#ifdef _DEBUG

  #include <stdio.h>

  #define Debug DebugPrintF

#else

  #define Debug (void)

#endif


#define UNREF(x) (void)(x)





//
// #########################################################################
//
// 
// 
// #########################################################################
//





static HINSTANCE GlobalInst;    //   





//
// #########################################################################
//
// 
//
// #########################################################################
//


HMIXER Mix;                   //  

HWND DlgWin;                  //   

MIXERLINE WOLine;             //   WaveOut

MIXERLINECONTROLS WOCtls;     //     WaveOut
MIXERCONTROL WOVolCtl;        //    WaveOut
MIXERCONTROL WOMuteCtl;       //    WaveOut

MIXERCONTROLDETAILS WOVolDet; //    
MIXERCONTROLDETAILS WOMuteDet; //    

MIXERCONTROLDETAILS_UNSIGNED WOVolVal; //   
MIXERCONTROLDETAILS_BOOLEAN WOMuteVal; //   





//
// #########################################################################
//
// 
//
// #########################################################################
//





//
//    
// ==========================
//

void Error (char *Text) {

  MessageBox (NULL, Text, "Error", MB_ICONERROR | MB_OK);

}





//
//      
// ======================================================
//

LONG DlgMsg (int Id, UINT Msg, LPARAM lp, WPARAM wp) {

  return SendDlgItemMessage (DlgWin, Id, Msg, lp, wp);

}




//
//    ComboBox 
// ====================================
//

void AddStringToCB (UINT Ctl, char *Str) {

  DlgMsg (Ctl,  CB_ADDSTRING,  0, (LPARAM)Str);

}





//
//  
// ====================
//

void CloseDevices (void) {


  //
  //    - 
  //

  if (Mix) {

    mixerClose (Mix);

    Mix = NULL;

  }


  //
  //    
  //

  ShowWindow (GetDlgItem (DlgWin, IDC_LineLabel), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_LineName), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_LineStatusLabel), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_LineStatus), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_VolLabel), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_Volume), SW_HIDE);
  ShowWindow (GetDlgItem (DlgWin, IDC_Mute), SW_HIDE);

}





//
//  
// ====================
//


int OpenDevices (void) {

  MMRESULT Res;
  

  //
  //  
  //

  Mix = NULL;


  //
  //      
  //

  int  DevN = DlgMsg (IDC_Mixer, CB_GETCURSEL, 0, 0);


  //
  //    ,   
  //

  Res = mixerOpen (
    &Mix,
    DevN,
    DWORD (DlgWin),
    0,
    CALLBACK_WINDOW
  );


  if (Res != MMSYSERR_NOERROR) {

    Error ("  ");

    return FALSE;

  }

  do {                          //   try - break


    //
    //      WaveOut
    //

    WOLine.cbStruct = sizeof (WOLine);
    WOLine.dwComponentType = MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT;

    Res = mixerGetLineInfo (
      HMIXEROBJ (Mix),
      &WOLine,
      MIXER_GETLINEINFOF_COMPONENTTYPE
    );

    if (Res != MMSYSERR_NOERROR) {

      Error ("    WaveOut");

      break;

    }  


    //
    //     (  - VOLUME)
    //

    WOCtls.cbStruct = sizeof (WOCtls);
    WOCtls.dwLineID = WOLine.dwLineID;
    WOCtls.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
    WOCtls.cControls = 1;
    WOCtls.cbmxctrl = sizeof (WOVolCtl);
    WOCtls.pamxctrl = &WOVolCtl;

    Res = mixerGetLineControls (
      HMIXEROBJ (Mix),
      &WOCtls,
      MIXER_GETLINECONTROLSF_ONEBYTYPE
    );

    if (Res != MMSYSERR_NOERROR) {

      Error ("    ");

      break;

    }  


    //
    //     (  - MUTE)
    //

    WOCtls.dwControlType = MIXERCONTROL_CONTROLTYPE_MUTE;
    WOCtls.cControls = 1;
    WOCtls.cbmxctrl = sizeof (WOMuteCtl);
    WOCtls.pamxctrl = &WOMuteCtl;

    Res = mixerGetLineControls (
      HMIXEROBJ (Mix),
      &WOCtls,
      MIXER_GETLINECONTROLSF_ONEBYTYPE
    );

    if (Res != MMSYSERR_NOERROR) {

      Error ("    ");

      break;

    }  


    //
    //    
    //

    WOVolDet.cbStruct = sizeof (WOVolDet);
    WOVolDet.dwControlID = WOVolCtl.dwControlID;
    WOVolDet.cChannels = 1;
    WOVolDet.cMultipleItems = 0;
    WOVolDet.cbDetails = sizeof (WOVolVal);
    WOVolDet.paDetails = &WOVolVal;

    WOMuteDet.cbStruct = sizeof (WOMuteDet);
    WOMuteDet.dwControlID = WOMuteCtl.dwControlID;
    WOMuteDet.cChannels = 1;
    WOMuteDet.cMultipleItems = 0;
    WOMuteDet.cbDetails = sizeof (WOMuteVal);
    WOMuteDet.paDetails = &WOMuteVal;

    return TRUE;

  } while (0);


  //
  //     
  //

  CloseDevices ();

  return FALSE;

}





//
//      
// ================================================
//

void UpdateDialogControls (void) {


  //
  //       
  //

  mixerGetLineInfo (HMIXEROBJ (Mix), &WOLine, MIXER_GETLINEINFOF_LINEID);

  char *Status = (
    (WOLine.fdwLine & MIXERLINE_LINEF_ACTIVE)? "" : ""
  );


  //
  //      
  //

  mixerGetControlDetails (
    HMIXEROBJ (Mix),
    &WOVolDet,
    MIXER_GETCONTROLDETAILSF_VALUE
  );

  mixerGetControlDetails (
    HMIXEROBJ (Mix),
    &WOMuteDet,
    MIXER_GETCONTROLDETAILSF_VALUE
  );


  //
  //        
  //

  DlgMsg (IDC_LineStatus, WM_SETTEXT, 0, LPARAM (Status));

  DlgMsg (
    IDC_Volume,
    TBM_SETPOS,
    TRUE,
    WOVolCtl.Bounds.dwMaximum - WOVolVal.dwValue
  );

  DlgMsg (
    IDC_Mute,
    BM_SETCHECK,
    WOMuteVal.fValue? BST_CHECKED : BST_UNCHECKED,
    0
  );


}





//
//      
// ===================================================
//

void UpdateMixerControls (void) {


  //
  //      
  //

  WOVolVal.dwValue = (
    WOVolCtl.Bounds.dwMaximum
    - DlgMsg (IDC_Volume, TBM_GETPOS, 0, 0)
  );

  WOMuteVal.fValue = DlgMsg (IDC_Mute, BM_GETCHECK, 0, 0);


  //
  //      
  //

  mixerSetControlDetails (
    HMIXEROBJ (Mix),
    &WOVolDet,
    MIXER_GETCONTROLDETAILSF_VALUE
  );

  mixerSetControlDetails (
    HMIXEROBJ (Mix),
    &WOMuteDet,
    MIXER_GETCONTROLDETAILSF_VALUE
  );
}





//
//    
// =====================================
//

BOOL CALLBACK DialogProc (HWND Win, UINT Msg, WPARAM wp, LPARAM lp) {

  DlgWin = Win;

  switch (Msg) {





    //
    //   
    // ==============================
    //

    case WM_INITDIALOG: {

      int N;
      int i;


      //
      //   
      //

      N = mixerGetNumDevs ();
      
      for (i = 0; i < N; i++) {
        
        MIXERCAPS Caps;

        mixerGetDevCaps (i, &Caps, sizeof (Caps));
        AddStringToCB (IDC_Mixer,  Caps.szPname);
        
      }

      return TRUE;

    }





    //
    //   
    // =========================
    //

    case MM_MIXM_LINE_CHANGE: {

      //
      //    -  
      //

      if (DWORD (lp) == WOLine.dwLineID) {

        UpdateDialogControls ();

      }

      return TRUE;

    }





    //
    //      
    // =================================================
    //

    case MM_MIXM_CONTROL_CHANGE: {

      //
      //    -  
      //

      if (
        DWORD (lp) == WOVolCtl.dwControlID
        || DWORD (lp) == WOMuteCtl.dwControlID
      ) {

        UpdateDialogControls ();

      }

      return TRUE;

    }





    //
    //      
    // ===============================================
    //

    case WM_VSCROLL: {

      //
      //     -  
      //

      if (HWND (lp) == GetDlgItem (DlgWin, IDC_Volume)) {

        UpdateMixerControls ();

        return TRUE;

      }

      break;

    }





    //
    //   Windows
    // ===========================
    //

    case WM_COMMAND: {

      UINT CtrlId = LOWORD (wp);
      UINT CtrlMsg = HIWORD (wp);
      
      switch (CtrlId) {
        

        //
        //      
        // =================================================
        //

        case IDC_Mute: {

          //
          //  
          //

          UpdateMixerControls ();

          return TRUE;

        }





        //
        //      (  )
        // =============================================================
        //

        case IDC_Mixer: {

          if (CtrlMsg == CBN_SELCHANGE) {

            CloseDevices ();    //   

            BOOL Res = OpenDevices (); //   

            if (!Res) {

              DlgMsg (IDC_Mixer, CB_SETCURSEL, -1, 0); //  

              return TRUE;

            }


            //
            //      
            //

            DlgMsg (IDC_LineName, WM_SETTEXT, 0, LPARAM (WOLine.szName));

            DlgMsg (IDC_VolLabel, WM_SETTEXT, 0, LPARAM (WOVolCtl.szShortName));
            DlgMsg (IDC_Mute, WM_SETTEXT, 0, LPARAM (WOMuteCtl.szShortName));


            //
            //    
            //

            DlgMsg (
              IDC_Volume,
              TBM_SETRANGEMIN,
              TRUE,
              WOVolCtl.Bounds.dwMinimum
            );

            DlgMsg (
              IDC_Volume,
              TBM_SETRANGEMAX,
              TRUE,
              WOVolCtl.Bounds.dwMaximum
            );


            //
            //   () 
            //

            UINT StepSize = (
              (WOVolCtl.Bounds.dwMaximum - WOVolCtl.Bounds.dwMinimum + 1)
              / WOVolCtl.Metrics.cSteps
            );

            DlgMsg (IDC_Volume, TBM_SETTICFREQ, StepSize, 0);


            //
            //    
            //

            UpdateDialogControls ();


            //
            //    
            //

            ShowWindow (GetDlgItem (DlgWin, IDC_LineLabel), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_LineName), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_LineStatusLabel), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_LineStatus), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_VolLabel), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_Volume), SW_SHOW);
            ShowWindow (GetDlgItem (DlgWin, IDC_Mute), SW_SHOW);

            return TRUE;

           }

          break;

        }



        //
        //    
        // ===========================
        //

        case IDCANCEL: {

          CloseDevices ();      //  

          EndDialog (DlgWin, 0); //   

          return TRUE;

        }


      }


    }


  }

  return FALSE;

}
      

//
//   Windows
// ========================
//

int WINAPI WinMain (
  HINSTANCE Instance,
  HINSTANCE PrevInstance,
  LPSTR Cmd,
  int CmdShow
) {

  int Result;
  

  //
  //     
  //

  InitCommonControls ();


  GlobalInst = Instance;


  //
  //   
  //

  Result = DialogBox (
    Instance, 
    MAKEINTRESOURCE (IDD_MainDialog),
    HWND_DESKTOP,
    DialogProc
  );


  return Result;

  UNREF (PrevInstance);
  UNREF (Cmd);
  UNREF (CmdShow);

}
